local Tinkr = ...


---@class Vision
local Vision = {
    DebugMode = false
}
Vision.__index = Vision

function Vision.require(class)
    return require("scripts/Vision/" .. class .. "/" .. class, Vision)
end


---@type EventManager
Vision.EventManager = Vision.require("EventManager"):New()

---@type Timer
Vision.Timer = Vision.require("Timer")

---@type TimeManager
Vision.TimeManager = Vision.require("TimeManager"):New()

local DeathTimer = Vision.TimeManager:GetTimer("DeathTimer", { "PLAYER_DEAD" }, { "PLAYER_UNGHOST" })

Vision.Enabled = true

Vision.Ticker = C_Timer.NewTicker(1, function()
    if Vision.Enabled then
        if DeathTimer:GetTime() > 60 then
            print("We have been dead for a minute or more.")
        end
    end
end)